diff --git a/src/lily_debug.c b/src/lily_debug.c
index ed426f05..1343c72c 100644
--- a/src/lily_debug.c
+++ b/src/lily_debug.c
@@ -354,7 +354,7 @@ static void show_code(lily_debug_state *debug)
 
         const int *opcode_data = optable[opcode];
         char *opcode_name = opcode_names[opcode];
-        int call_type, count, data_code, is_global, j;
+        int call_type = 0, count = 0, data_code, is_global = 0, j;
 
         /* Group under a new line number if the current one isn't the last one
            seen. This makes it easy to see what operations that are caused by
diff --git a/src/lily_emitter.c b/src/lily_emitter.c
index 30527fbd..88301749 100644
--- a/src/lily_emitter.c
+++ b/src/lily_emitter.c
@@ -3055,8 +3055,6 @@ void lily_emit_return(lily_emit_state *emit, lily_ast *ast)
     writes an initialization for the hidden self variable. */
 void lily_emit_class_init(lily_emit_state *emit)
 {
-    lily_class *cls = emit->current_class;
-
     /* The most recent function is the constructor for this class, which will
        always return a class instance. Since it's also the function var (and
        the return of a function is always [0], this works. */
@@ -3065,8 +3063,6 @@ void lily_emit_class_init(lily_emit_state *emit)
     lily_storage *self = get_storage(emit, self_sig, *emit->lex_linenum);
     emit->current_block->self = self;
 
-    lily_function_val *f = emit->top_function;
-
     write_3(emit,
             o_new_instance,
             *emit->lex_linenum,
diff --git a/src/lily_lexer.c b/src/lily_lexer.c
index c2290d80..642edc48 100644
--- a/src/lily_lexer.c
+++ b/src/lily_lexer.c
@@ -1,3 +1,4 @@
+#include <ctype.h>
 #include <string.h>
 #include <errno.h>
 
@@ -673,27 +674,31 @@ static void scan_number(lily_lex_state *lexer, int *pos, lily_token *tok,
     else
         integer_value = scan_decimal(lexer, &num_pos, &is_integer, new_ch);
 
-    if (is_negative == 0) {
-        if (integer_value <= INT64_MAX)
-            yield_val.integer = (int64_t)integer_value;
-        else
-            lily_raise(lexer->raiser, lily_SyntaxError,
-                       "Integer value is too large.\n");
-    }
-    else {
-        /* This is negative, and signed min is 1 higher than signed max. This is
-           written as a literal so that gcc doesn't complain about overflow. */
-        uint64_t max = 9223372036854775808ULL;
-        if (integer_value <= max)
-            yield_val.integer = -(int64_t)integer_value;
-        else
-            lily_raise(lexer->raiser, lily_SyntaxError,
-                       "Integer value is too large.\n");
+    if (is_integer) {
+        /* This won't be used uninitialized. I promise. */
+        yield_val.doubleval = 0.0;
+        if (is_negative == 0) {
+            if (integer_value <= INT64_MAX)
+                yield_val.integer = (int64_t)integer_value;
+            else
+                lily_raise(lexer->raiser, lily_SyntaxError,
+                           "Integer value is too large.\n");
+        }
+        else {
+            /* This is negative, and signed min is 1 higher than signed max. This is
+               written as a literal so that gcc doesn't complain about overflow. */
+            uint64_t max = 9223372036854775808ULL;
+            if (integer_value <= max)
+                yield_val.integer = -(int64_t)integer_value;
+            else
+                lily_raise(lexer->raiser, lily_SyntaxError,
+                           "Integer value is too large.\n");
+        }
+        *tok = tk_integer;
     }
-
     /* Not an integer, so use strtod to try converting it to a double so it can
        be stored as a double. */
-    if (is_integer == 0) {
+    else {
         double double_result;
         char *input_buffer = lexer->input_buffer;
         int str_size = num_pos - num_start;
@@ -710,8 +715,6 @@ static void scan_number(lily_lex_state *lexer, int *pos, lily_token *tok,
         yield_val.doubleval = double_result;
         *tok = tk_double;
     }
-    else
-        *tok = tk_integer;
 
     *pos = num_pos;
     lexer->value = yield_val;
diff --git a/src/lily_parser.c b/src/lily_parser.c
index 57ef306c..f93ff3ef 100644
--- a/src/lily_parser.c
+++ b/src/lily_parser.c
@@ -508,6 +508,8 @@ static lily_sig *collect_var_sig(lily_parse_state *parser, lily_class *cls,
             else
                 call_var = get_named_var(parser, call_sig, 0);
         }
+        else
+            call_var = NULL;
 
         /* Collect generics and call type collection as usual. Don't bother
            updating template information: Part of building signatures will
diff --git a/src/lily_symtab.h b/src/lily_symtab.h
index b94dc30a..fe34cedf 100644
--- a/src/lily_symtab.h
+++ b/src/lily_symtab.h
@@ -89,4 +89,5 @@ lily_prop_entry *lily_add_class_property(lily_class *, lily_sig *, char *);
 void lily_set_class_generics(lily_symtab *, int);
 void lily_finish_class(lily_symtab *, lily_class *);
 void lily_make_constructor_return_sig(lily_symtab *);
+void lily_reserve_generics(lily_symtab *, int);
 #endif
